
public class GenericStack<T>
{
    private T[] items;
    private int top;   // Index of the next push; OR # of T's in stack

    public GenericStack(int size)
    {
        this.top = 0;
        this.items = (T[]) new Object[size];

    }

    public boolean isEmpty()
    {
        return top == 0;


    }

    public boolean isFull()
    {
        return items.length == top;
    }

    public void push(T item)
    {
        if(!isFull())
        {
            items[top] = item;  // Place in next empty slot
            ++top;              // Move next "up"
        }
    }

    public T pop()
    {
        if(isEmpty()){
            return null;
        }
        else
        {
            --top;
            return(items[top]);
        }
    }
    
    public String report()
    {
        String out = "*************\n";
        for(int i = top-1; i >= 0; --i)
        {
            out += items[i].toString() + "\n";
        }
        out += "************\n";
        
        return out;
        
    }

}
